<template>
  <div id="main">
    <header>
      <h1>Tamagopg</h1>
      <p>Vivez une aventure incroyable !</p>
    </header>
    <div id="wrapper">
      <main>
        <div id="heros">
          <div class="header">Mon équipe</div>
          <div class="content">
            <CCharacter :entity="game.player.character"/>
            <CCharacter v-for="(a,i) in game.allies" v-bind:key="i" :entity="a"/>
          </div>
        </div>
        <div id="controllers" v-if="!game.player.in_fight">

          <div class="btn" @click="attack">
            Les attaquer
            <img class="btn-icon" :src="iattack" />
          </div>

          <div class="btn" @click="rest">
            <div class="btn-progress" :style="{height: game.player.btn_delay(0)}"></div>
            Se reposer
            <div class="btn-group">
              <div class="btn-group">
                <img class="btn-icon" :src="irest" alt="">
                + 75
              </div>
             <div class="btn-group">
               <img class="btn-icon" :src="ifood" alt="">
               <span>- 15</span>
             </div>
            </div>
          </div>

          <div class="btn" @click="eat">
            <div class="btn-progress" :style="{height: game.player.btn_delay(1)}"></div>
            Se nourrir
            <div class="btn-group">
              <div class="btn-group">
                <img class="btn-icon" :src="ifood" alt="">
                + 75
              </div>
              <div class="btn-group">
                <img class="btn-icon" :src="irest" alt="">
                <span>+ 10</span>
              </div>
            </div>
          </div>
          <div class="btn" @click="heal">
            <div class="btn-progress" :style="{height: game.player.btn_delay(2)}"></div>
            Se soigner
            <div class="btn-group">
              <div class="btn-group">
                <img class="btn-icon" :src="iheal" alt="">
                + 5
              </div>
              <div class="btn-group">
                <img class="btn-icon" :src="irest" alt="">
                <span>- 15</span>
              </div>
            </div>
          </div>
        </div>
        <div id="ennemies">
          <div class="header">Se battre contre</div>
          <div class="content">
            <CEntity v-for="(e, i) in game.getDungeonFloor().entities" :key="i" :entity="e"/>
          </div>
        </div>
      </main>
      <aside>
        <div class="header">Informations</div>
        <div class="content">
          <section>
            <h3>Donjon</h3>
            <p>Donjon: <span>{{ game.getDungeon().name }}</span></p>
            <p>Etage: {{ game.getFloor() }}</p>
            <p>Monstres: {{ game.getDungeonFloor().monsters() }}</p>
          </section>
          <section v-if="meteo">
            <h3>Météo</h3>
            <p>Ville: {{ meteo.name }}</p>
            <p>Humidité: {{ meteo.main.humidity }}%</p>
            <p>Température: {{ game.meteo.temp }}°C</p>
            <p>Vent: {{ meteo.wind.speed }}m/s</p>
            <p v-if="meteo.weather">Nuage: {{ meteo.weather[0].description }}</p>
          </section>
        </div>
      </aside>
    </div>

  </div>
</template>

<script>
import {Game} from "../game/game";
import CEntity from "./characters/CEntity";
import CCharacter from "./characters/CCharacter";

import food from '../../src/assets/img/food.png';
import rest from '../../src/assets/img/resting.png';
import heal from '../../src/assets/img/heal.png';
import attack from '../../src/assets/img/attack.png';

export default {
  name: "Main",
  components: {CEntity, CCharacter},
  props: {
    game: Game,
  },
  data: function() {
    return {
      meteo: null,
      ifood: food,
      irest: rest,
      iattack: attack,
      iheal: heal,

      heat: "0%",
      hrest: "0%",
      hheal: "0%"
    }
  },
  methods: {
    attack: function() {
      this.game.start();
    },
    rest: function() {
      this.game.rest();
    },
    eat: function() {
      this.game.eat();
    },
    heal: function() {
      this.game.heal();
    },
    getWeather: function(){
      try {
        const response = new XMLHttpRequest();
        response.open('GET', "http://api.openweathermap.org/data/2.5/weather?q=Montpellier&appid=fb395e46ef1ac13ddf02dcaa484870ae&lang=FR");

        response.responseType = 'json';
        response.send(null);

        response.onload = () => {
          this.meteo = response.response;
          this.game.ambiant(this.meteo);
        }
      } catch (error) {
        console.log(error);
      }
    }
  },
  created() {
    this.getWeather();
  }
}
</script>

<style scoped>

#main {
  width: 100%;
}

header {
  text-align: center;
}

main {
  margin: 0 auto;
  flex: 1 1 auto;
}

#wrapper {
  display: flex;
  flex-flow: row wrap;
  justify-content: center;
  align-items: stretch;
  margin-top: 32px;
}

aside {
  flex: 1 1 auto;
  max-width: 350px;
  border-left: 1px solid gray;
}

section:not(:first-child) {
  margin-top: 32px;
}

#heros {
  display: flex;
  flex-flow: column;
  justify-content: stretch;
}

#controllers {
  display: flex;
  flex-flow: row wrap;
  justify-content: center;
  align-items: center;
}

#ennemies {
  margin-top: 32px;
  display: flex;
  flex-flow: column;
  justify-content: stretch;
}

.header {
  font-size: 17pt;
  text-align: center;
}

.content {
  display: flex;
  flex-flow: row wrap;
  justify-content: center;
  align-items: stretch;
}

aside .content {
  flex-flow: column nowrap;
  padding: 0 16px;
}

aside span {
  font-weight: bold;
}

</style>